--- old/usr/src/uts/common/fs/zfs/zio.c	Fri Apr 20 04:05:12 2012
+++ new/usr/src/uts/common/fs/zfs/zio.c	Fri Apr 20 04:05:11 2012
@@ -2111,8 +2111,12 @@
 
 	ddt_enter(ddt);
 	freedde = dde = ddt_lookup(ddt, bp, B_TRUE);
-	ddp = ddt_phys_select(dde, bp);
-	ddt_phys_decref(ddp);
+	if (dde) {
+		ddp = ddt_phys_select(dde, bp);
+		if (ddp) {
+			ddt_phys_decref(ddp);
+		}
+	}
 	ddt_exit(ddt);
 
 	return (ZIO_PIPELINE_CONTINUE);
